function [D, rawD, varNames, labelMapper, uniqueCounts] = readSpliceData(path)
%READSPLICEDATA Summary of this function goes here
%   Detailed explanation goes here

[c1, c2, c3] = textread(path, '%s%s%s', 'delimiter', ',');
I = length(c1);
n = length(c3{1});

rawD = cell(I, n + 1);
varNames = cell(1, n + 1);
labelMapper = cell(1, n + 1);
uniqueCounts = zeros(1, n + 1);

for i = 1 : I
    for j = 1 : n
        rawD{i, j} = c3{i}(j);
    end
    rawD{i, n + 1} = c1{i};
end

for j = 1 : n
    varNames{j} = ['X' num2str(j)];
    labelMapper{j} = unique(rawD(:, j));  
    uniqueCounts(j) = length(labelMapper{j});
end
varNames{n + 1} = 'Y';
labelMapper{n + 1} = unique(rawD(:, n + 1));
uniqueCounts(n + 1) = length(labelMapper{n + 1});

for i = 1 : I
    for j = 1 : n + 1
        D(i, j) = find(strcmp(labelMapper{j}, rawD{i, j}) == 1);
    end
end
end

